#include "BITON.CH"
#include "ACHOICE.CH"
#include "INKEY.CH"
*********************************
* O_dbu11.prg    
*
* List Users
*********************************
Save Screen to Bit_scr1
*********************************
* Set up Arrays & scroll Windows
* for user listing
*================================
* User Window: 02,01,14,35
* User Rights: 02,40,05,55     - Non Scroll
* User Tables: 08,40,20,75
*********************************
* Arrays
* User_col      = Username Column
* Tabl_crea     = Table Creators
* Conn_col      = Connect Column
* Res_col       = Resource Column
* Dba_col       = Dba Column
* Tname         = Table Name
* A_dbsize      = Size of Field on Database
* A_flsize      = Fetch Size of Field
* A_fltype      = Data type
* A_flname      = Field Name
*--------------------------------
Declare Tname[1], A_dbsize[1], A_flsize[1], A_fltype[1], A_flname[1]

win1_row := 3
win1_col := 2
win2_row := 9
win2_col := 41

p_key    := 0                 /* Inkey */
p_key1   := 0
user_cnt := Space(22)
user_cnt1:= 0
user_rec := 1


tabl_cnt := Space(22)
tabl_cnt1:= 0
tabl_rec := 1

crea_cnt := SPACE(22)
crea_cnt1:= 0

cnt      := 0                   /* Count Vars */
cnt1     := 0
*--------------------------------
* Windows
*--------------------------------
* User Window
Setcolor(p_colshade)
@ 03,02 Clear to 15,36
Setcolor(p_colawind)
@ 02,01 Clear To 14,35
@ 02,01 To 14,35
@ 02,15 Say Chr(180)+'Users'+Chr(195)
Scroll(03,02,13,34,0)

* Rights Window
Setcolor(p_colshade)
@ 03,41 Clear to 6,56
Setcolor(p_colawind)
@ 02,40 Clear To 05,55
@ 02,40 To 05,55
@ 02,44 Say Chr(180)+'Rights'+Chr(195)
@ 03,41 Say 'Conn'
@ 03,47 Say 'Res'
@ 03,51 Say 'Dba'

* User Tables
Setcolor(p_colshade)
@ 09,41 Clear to 21,76
Setcolor(p_colawind)
@ 08,40 Clear To 20,75
@ 08,40 To 20,75
@ 08,54 Say Chr(180)+'Tables'+Chr(195)
Scroll(09,41,19,74,0)

* Key Hit Window
Setcolor(p_colshade)
@ 17,02 Clear to 22,36
Setcolor(p_colawind)
@ 16,01 Clear To 21,35
@ 16,01 To 21,35
@ 16,11 Say Chr(180)+'Key Options'+Chr(195)
@ 17,02 Say 'Esc - Back Out'
@ 18,02 Say CHR(24)+' Up'
@ 19,02 Say Chr(25)+' Down'
@ 18,19 Say 'Ins - Add User  '
@ 19,19 Say 'Del - Drop User '

***********************************
Do while .t.
  *=====================*
  * Set up User Array   *
  *=====================*
  Bit_status('......Loading User Information')

  SQLEXEC SELECT FOR 1 COUNT(*) FROM &User_table Into @User_cnt


  O_orclpnum(User_cnt, @User_cnt1)

  Declare User_col[user_cnt1] ,Conn_col[user_cnt1]  ,Res_col[user_cnt1],;
          Dba_col[user_cnt1] 

  cnt := 1
  Do While cnt <= User_cnt1
     User_col[cnt] := Space(30)
     Conn_col[cnt] := Space(1)
     Res_col[cnt]  := Space(1)
     Dba_col[cnt]  := Space(1)
     cnt++
  Enddo

  SQLEXEC SELECT FOR user_cnt1 &User_col1,&User_col2,&User_col3,&User_col4 ;
                               FROM &User_table ; 
                               ORDER BY &User_col1 ;
                               INTO User_col,Conn_col,Res_col,Dba_col


  cnt1 = Ascan(User_col,SPACE(30))

  If cnt1 != 0                 && ---- Sometimes Occurs
     ADEL(User_col,cnt1)
     ADEL(Conn_col,cnt1)
     ADEL(Res_col,cnt1)
     ADEL(Dba_col,cnt1)
  Endif

  *------------------------
  * Get Creators from 
  * Table_audit
  *------------------------
  SQLEXEC SELECT FOR 1 DISTINCT COUNT(&Audit_col1) FROM &Audit_table ; 
                                                    Into @crea_cnt
  O_orclpnum(crea_cnt, @crea_cnt1)

  Declare Tabl_crea[crea_cnt1]

  cnt := 1
  Do while cnt <= Len(Tabl_crea)
     Tabl_crea[cnt] := Space(30)
     cnt++
  Enddo

  SQLEXEC SELECT FOR crea_cnt1 DISTINCT &Audit_col1 ;
                               FROM &Audit_table ; 
                               ORDER BY &Audit_col1 ;
                               INTO Tabl_crea

  
  Bit_status()

  Setcolor(p_colawind)
  User_disp(1)                           && ---- Show first User
  cnt := 1

  While .t.
    cnt := Achoice(03,02,13,34,User_col,.T.,"Us_choic",cnt)

    If cnt > Len(User_col)
       cnt := Len(User_col)
    Endif   

	If cnt == 0 
       Exit
    Endif

  Enddo

***********************************
Restore Screen from Bit_scr1

Return
Enddo
*****************************************************
* Functions
*****************************************************
* User_disp()        -- Display User
* Us_choic ()        -- Achoice on Users
* Tabl_desc()        -- Describe Table
* Tabl_opt()         -- Process Table
* Tb_choic()         -- Achoice on Table
* User_ins()         -- Add a User
* User_del()         -- Delete User
*====================================================
********************************************************
* User_disp()
********************************************************
Function User_disp(us_elem)

*-----------------------
* Show Rights
*-----------------------
If Conn_col[us_elem] == 'Y'
   @ 04,43 Say Chr(251)
Else
  @ 04,43 Say ' '
Endif

If Res_col[us_elem] == 'Y'
   @ 04,48 Say Chr(251)
Else
  @ 04,48 Say ' '
Endif

If Dba_col[us_elem] == 'Y'
   @ 04,52 Say Chr(251)
Else
  @ 04,52 Say ' '
Endif

*------------------------
* Get Tables for first User
*------------------------

user_name := ALLTRIM(user_col[us_elem])

Scroll(09,41,19,74,0)

If Ascan(Tabl_crea,user_col[us_elem]) != 0           && ---- No Tables
   @ 14,51 Say 'Tables Exist'
   Setcolor(p_colawind)
   @ 20,02 Say Chr(26)+' See Tables'
Else
   @ 14,50 Say 'No Tables'
   tabl_cnt1 := 0
   Setcolor(p_colawind)
   @ 20,02 Say '            '
Endif

Return .T.

********************************************************
* Tabl_opt()
********************************************************
Function Tabl_opt(user_elem)
@ 18,19 Say '<cr> - See Struc'
@ 19,19 Say 'F4   - Browse   '

tabl_rec := user_elem


If Type("Tname") != "U"
   Rele Tname
Endif

user_name := ALLTRIM(user_col[user_elem])

SQLEXEC SELECT FOR 1 DISTINCT COUNT(&Audit_col2) FROM &Audit_table ;
        WHERE &Audit_col1 = "&user_name" ;
        INTO @tabl_cnt

O_orclpnum(tabl_cnt, @tabl_cnt1)

Declare Tname[tabl_cnt1]

Afill(Tname,Space(30))

If tabl_cnt1 == 1
   Tname1 := Tname[1]
   SQLEXEC SELECT FOR 1 DISTINCT &Audit_col2 FROM &Audit_table ;
                  WHERE &Audit_col1 ='&user_name' ;
                  Into @Tname1
   Tname[1] := Tname1
   Rele Tname1
Else
   SQLEXEC SELECT FOR tabl_cnt1 DISTINCT &Audit_col2 FROM &Audit_table ;
                  WHERE &Audit_col1 ='&user_name' ;
                  Into Tname
Endif
/*******************************
 Do this cos Oracle brings back
 Spaces for some duplicate views
 *******************************/
While .T.
   cnt1 = Ascan(Tname,SPACE(30))
     
   If cnt1 != 0
      Adel(Tname,cnt1)
   Else
      Exit
   Endif

Enddo


*------------------------
* Display First 10
*------------------------
Setcolor(p_colawind)
cnt      := 1
win2_row := 9

Scroll(09,41,19,74,0)

Do while .T.
   cnt := Achoice(09,41,19,74,Tname,.T.,"Tb_choic")

   If cnt == 0
      Exit
   Endif

Enddo

@ 20,19 Say '                '

Return .T.
********************************************************
* Tabl_show()
********************************************************
Function Tabl_show(tb_elem)

m_numfld  := 0
p_key2    := 0

Bit_status('Wait')
tab_name := ALLTRIM(user_col[tabl_rec])+'.'+ALLTRIM(Tname[tb_elem])

SQLEXEC DESCRIBE NUMBER OF FIELDS IN TABLE &tab_name Into m_numfld

If m_numfld == 0
   Return .T.
Endif

If Type("A_dbsize") != "U"
   Rele A_dbsize, A_flsize, A_flname, A_fltype
Endif

Declare A_dbsize[m_numfld], A_flsize[m_numfld], A_flname[m_numfld],;
        A_fltype[m_numfld]

Afill(A_dbsize,0)
Afill(A_flsize,0)
Afill(A_fltype," ")
Afill(A_flname,Space(20))


SQLEXEC DESCRIBE TABLE &tab_name Into A_dbsize, A_flsize, A_fltype, A_flname

Bit_status()

*========================
* All Info Here
*========================

Save screen to Bit_scr2

Setcolor(p_colshade)
@ 08,09 Clear to 20,53
Setcolor(p_colawind)
@ 07,10 Clear To 19,54
@ 07,10 To 19,54
@ 07,25 Say Chr(180)+'Description'+Chr(195)
Scroll(10,12,18,53,0)

@ 08,11 Say 'Field Name'
@ 08,34 Say 'Data'
@ 08,41 Say 'Fetch'
@ 08,49 Say 'Field'
@ 09,34 Say 'Length'
@ 09,41 Say 'Length'
@ 09,49 Say 'Type'

For cnt := 1 To 9
   @ 10+(cnt-1),13 Say A_flname[cnt] Picture 'XXXXXXXXXXXXXXXXXXXX'
   @ 10+(cnt-1),34 Say A_dbsize[cnt] Picture '9999'
   @ 10+(cnt-1),41 Say A_flsize[cnt] Picture '9999'
   @ 10+(cnt-1),49 Say A_fltype[cnt] Picture 'X'
   If cnt == Len(A_dbsize)
      Exit
   Endif
Next

t_row := 10                                        && ---- Temp Row
cnt := 1

Do While .T.

  @ t_row,12 Say  '>'
  p_key2 := Inkey()

  Do Case
  Case p_key2 == 0
     Loop
  Case p_key2 == K_ESC
     Exit

  Case p_key2 == K_DOWN

     cnt++
     t_row++

     If cnt > Len(A_dbsize)
        cnt--
        t_row--
        Loop
     Endif


     If t_row > 18
        Scroll(10,12,18,53,1)
        t_row := 18
        @ t_row-1,12 Say ' '
     Else
        @ t_row-1,12 Say ' '                 /* Clear Arrow */
     Endif

  Case p_key2 == K_UP

     cnt--
     t_row--

     If cnt < 1
        cnt++
        t_row++
        Loop
     Endif


     If t_row < 10
        Scroll(10,12,18,53,-1)
        @ t_row+2,12 Say ' '                 /* Clear Arrow */
        t_row := 10
     Else
        @ t_row+1,12 Say ' '                 /* Clear Arrow */
     Endif
       
  Other
 
     Loop
  Endcase

  @ t_row,13 Say A_flname[cnt] Picture 'XXXXXXXXXXXXXXXXXXXX'
  @ t_row,34 Say A_dbsize[cnt] Picture '9999'
  @ t_row,41 Say A_flsize[cnt] Picture '9999'
  @ t_row,49 Say A_fltype[cnt] Picture 'X'
  @ t_row,12 Say '>'

Enddo




Restore Screen from Bit_scr2
Return .T.

/**********************************/
 Function Us_choic(ac_mode,ac_elem,ac_row)

 Do Case
 Case ac_mode == AC_IDLE .Or. ac_mode == AC_NOITEM
    User_disp(ac_elem)
    Return AC_CONT

 Case ac_mode == AC_PASTTOP .Or. ac_mode == AC_PASTEND
    Return AC_CONT

  Other

    Do Case
    Case Lastkey() == K_ESC
       Return AC_ABORT

    Case Lastkey() == K_RIGHT
       Inkey()

       If Ascan(tabl_crea,User_col[ac_elem]) != 0
          tabl_opt(ac_elem)
          @ 18,19 Say 'Ins - Add User  '
          @ 19,19 Say 'Del - Drop User '
       Endif

       Return AC_CONT

    Case Lastkey() == K_INS                     && ---- Insert a User
       User_ins()

       Return AC_SELECT

    Case Lastkey() == K_DEL                     && ---- Delete a User

       User_del(ac_elem)

       Return AC_SELECT

    Case Lastkey() == K_HOME .or. Lastkey() == K_END .or. Lastkey() == K_ENTER;
                    .or. Lastkey() == K_LEFT
       Inkey()
       Return AC_CONT

    Other
       Return AC_GOTO

    Endcase
 Endcase

Return AC_CONT
/**********************************/
 Function Tb_choic(ac_mode,ac_elem,ac_row)

 Do Case
 Case ac_mode == AC_IDLE .Or. ac_mode == AC_NOITEM ;
                 .or. ac_mode == AC_PASTTOP .Or. ac_mode == AC_PASTEND
    Return AC_CONT

 Other

    Do Case
    Case Lastkey() == K_ESC
       Return AC_ABORT

    Case Lastkey() == K_ENTER
       inkey()
       tabl_show(ac_elem)
       Return AC_CONT

    Case Lastkey() == K_LEFT
       Inkey()

       Return AC_ABORT

    Case Lastkey() == K_F4
       m_table := ALLTRIM(user_col[tabl_rec])+'.'+ALLTRIM(Tname[ac_elem])
       TV_browse("&m_table",01,01,21,79)
       
    Other

       Inkey()
       Return AC_CONT

    Endcase

 Endcase

Return AC_CONT
/**********************************/
 Function User_ins()
 /*********************************
  Adds a User, then reloads Base values
  and Redisplays
  *********************************/
 m_uid := Space(30)
 m_pwd := Space(30)
 m_type:= ' '                       /* CRD */
 m_add := 'N'

 Save Screen to Bit_scr2
 uid_col := Setcolor()

 Setcolor(p_colshade)
 @ 11,11 Clear to 17,53
 Setcolor(p_colawind)
 @ 10,10 Clear to 16,52
 @ 10,10 to 16,52
 @ 10,25 Say Chr(180)+'Add Users'+Chr(195)
 @ 11,11 Say 'User Name:'
 @ 12,11 Say 'Password :'
 @ 13,11 Say 'Access   :'
 @ 13,25 Say 'Connect/Resource/Dba'
 Setcolor(p_colerr)
 @ 13,25 Say 'C'
 @ 13,33 Say 'R'
 @ 13,42 Say 'D'
 Setcolor(p_colwinp)
 /**********************
  Window Set up
  **********************/
 While .T.
    @ 11,22 Clear to 12,33
    @ 13,22 Say ' '
    m_uid := Space(30)
    m_pwd := Space(30)
    m_type:= ' '                       /* CRD */

    @ 11,22 Get m_uid Picture '!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
    @ 12,22 Get m_pwd Picture '!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
    @ 13,22 Get m_type Picture '!' Valid m_type == 'C' .or.;
                                         m_type == 'R' .or.;
                                         m_type == 'D'

    Read

    If m_uid == Space(30)
       Exit
    Endif


    /***************************
     Check Entry
     ***************************/
     Bit_scr3 := Savescreen(15,10,18,32)
     Setcolor(p_colerrbox)
     @ 15,10 Clear To 18,32
     @ 15,10 To 18,32 Double
     Setcolor(p_colerrmess)
        
     @ 16,11 Say ' Hit Enter to Accept'
     @ 17,12 Say '   Esc to Ignore    '
     Set Cursor Off
     * 
     Do While .T.
        i=Inkey()
   
        Do Case
        Case i=0
           Loop
        Case i == 27 .or. i == 13
           Exit
        Other
           Loop
        Endcase
   
     Enddo

     Restscreen(15,10,18,32,Bit_scr3)
     Rele Bit_scr3
     Setcolor(p_colwinp)

     If i == 27                         /* Escape */
        Loop
     Endif

     /**************************
      End Check
      **************************/

     m_uid := Alltrim(m_uid)
     m_pwd := Alltrim(m_pwd)

     Do Case
     Case m_type == 'C'
        SQLEXEC GRANT CONNECT TO &m_uid IDENTIFIED BY &m_pwd

     Case m_type == 'R'
        SQLEXEC GRANT CONNECT, RESOURCE TO &m_uid ;
                      IDENTIFIED BY &m_pwd
       
     Case m_type == 'D'
        SQLEXEC GRANT CONNECT, RESOURCE, DBA TO &m_uid ;
                     IDENTIFIED BY &m_pwd
     Endcase

     If o_errno() != 0
        Bit_error()
        Loop
     Endif

     /***** Add Temp *****/
     Aadd(User_col,'temp')
     Aadd(Conn_col,'temp')
     Aadd(Res_col,'temp')
     Aadd(Dba_col,'temp')

    /**** Find correct Element */
     t_elem := 1

     Do While .t.     

       If User_col[t_elem] == NIL
          Exit
       Endif

       If m_uid < User_col[t_elem]
          Exit
       Endif

       t_elem++
     Enddo

    /*** Insert into Arrays */
     Ains(User_col,t_elem)
     Ains(Conn_col,t_elem)
     Ains(Res_col,t_elem)
     Ains(Dba_col,t_elem)
    /*Add Values */

     User_col[t_elem] := m_uid
     Conn_col[t_elem] := 'Y'

     If m_type != 'C'
        Res_col[t_elem] := 'Y'

        If m_type == 'D'
           Dba_col[t_elem] := 'Y'
        Endif
     Endif

     Bit_status('.....User Added.', 'Y')
 Enddo


 Setcolor(uid_col)
 Rele uid_col
 Restore Screen From Bit_scr2

 Return .T.
/**********************************/
 Function User_del(ac_elem)
 /*********************************
  Revokes a User or Part thereof,
  Reassigns arrays if Connect 
  Revoked
  *********************************/
 m_uid := Space(30)
 m_type:= ' '                       /* CRD */
 m_del := 'N'
 m_cre := 0

/**********************************
 Guard against illegal deletions
 **********************************/

 If Substr(User_col[ac_elem],1,6) == 'SYSTEM' .or.;
    Substr(User_col[ac_elem],1,3) == 'SYS' .or. ;
    Substr(User_col[ac_elem],1,6) == 'PUBLIC'
    O_errwrite(-4,"Cannot Delete This User")
    Bit_error()
    Return .T.
 Endif
 /**********************************
  O.K. from here
  **********************************/

 Save Screen to Bit_scr2
 uid_col := Setcolor()

 Setcolor(p_colshade)
 @ 11,11 Clear to 16,53
 Setcolor(p_colawind)
 @ 10,10 Clear to 15,52
 @ 10,10 to 15,52
 @ 10,23 Say Chr(180)+'Delete Users'+Chr(195)
 @ 11,11 Say 'User Name:'
 @ 12,11 Say 'Access   :'
 @ 12,25 Say 'Connect/Resource/Dba'
 Setcolor(p_colmenlet)
 @ 12,25 Say 'C'
 @ 12,33 Say 'R'
 @ 12,42 Say 'D'
 Setcolor(p_colwinp)
 /**********************
  Window Set up
  **********************/
 m_uid := User_col[ac_elem]

 While .T.
    @ 11,22 Clear to 11,33
    @ 12,22 Say ' '
    m_type:= ' '                       /* CRD */

    @ 11,22 Say m_uid Picture '!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
    @ 12,22 Get m_type Picture '!' Valid m_type == 'C' .or.;
                                         m_type == 'R' .or.;
                                         m_type == 'D'

    Read

    /***************************
     Check Entry
     ***************************/
     Bit_scr3 := Savescreen(15,10,18,32)
     Setcolor(p_colerrbox)
     @ 15,10 Clear To 18,32
     @ 15,10 To 18,32 Double
     Setcolor(p_colerrmess)
        
     @ 16,11 Say ' Hit Enter to Accept'
     @ 17,12 Say '   Esc to Ignore    '
     Set Cursor Off
     * 
     Do While .T.
        i=Inkey()
   
        Do Case
        Case i=0
           Loop
        Case i == 27 .or. i == 13
           Exit
        Other
           Loop
        Endcase
   
     Enddo

     Restscreen(15,10,18,32,Bit_scr3)
     Rele Bit_scr3
     Setcolor(p_colwinp)

     If i == 27
        Exit
     Endif

     /**************************
      End Check
      **************************/

     m_uid := Alltrim(m_uid)

     Do Case
     Case m_type == 'C'
        SQLEXEC REVOKE CONNECT FROM &m_uid 
        Adel(User_col,ac_elem)
        Adel(Conn_col,ac_elem)
        Adel(Res_col,ac_elem)
        Adel(Dba_col,ac_elem)

        m_cre = Ascan(Tabl_crea,m_uid)

        If m_cre != 0                     /* Delete from Table Owners */
           Adel(Tabl_crea,m_cre)
        Endif
        
        m_del := 'Y'

     Case m_type == 'R'
        SQLEXEC REVOKE RESOURCE FROM &m_uid 
        Res_col[ac_elem] := ' '
        Dba_col[ac_elem] := ' '
       
     Case m_type == 'D'
        SQLEXEC REVOKE DBA FROM &m_uid 
        Dba_col[ac_elem] := ' '

     Endcase

     If o_errno() != 0
        Bit_error()
     Endif

     Exit
 Enddo

 Setcolor(uid_col)
 Rele uid_col
 Restore Screen From Bit_scr2

 Return .T.
